{
    $Id: alpha.pas,v 1.2 1998/09/09 20:14:00 peter Exp $
    Copyright (C) 1997 by Florian Klaempfl

    this unit implements an asmlistitem class for the DEC Alpha

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************
}
unit alpha;

  interface

    uses
       strings,systems,cobjects,globals,aasm;

    type
       tasmop = (A_ADDF,A_ADDG,A_ADDL,A_ADDQ,
                 A_ADDS,A_ADDT,A_AMASK,A_AND,A_BEQ,A_BGE,
                 A_BGT,A_BIC,A_BIS,A_BLBC,A_BLBS,A_BLE,
                 A_BLT,A_BNE,A_BR,A_BSR,A_CALL_PAL,A_CMOVEQ,
                 A_CMOVGE,A_CMOVGT,A_CMOVLBC,A_CMOVLBS,A_CMOVLE,A_CMOVLT,
                 A_CMOVNE,A_CMPBGE,A_CMPEQ,A_CMPGEQ,A_CMPGLE,A_CMPGLT,
                 A_CMPLE,A_CMPLT,A_CMPTEQ,A_CMPTLE,A_CMPTLT,A_CMPTUN,
                 A_CMPULE,A_CMPULT,A_CPYS,A_CPYSE,A_CPYSN,A_CTLZ,
                 A_CTPOP,A_CTTZ,A_CVTDG,A_CVTGD,A_CVTGF,A_CVTGQ,
                 A_CVTLQ,A_CVTQF,A_CVTQG,A_CVTQL,A_CVTQS,A_CVTQT,
                 A_CVTST,A_CVTTQ,A_CVTTS,A_DIVF,A_DIVG,A_DIVS,
                 A_DIVT,A_ECB,A_EQV,A_EXCB,A_EXTBL,A_EXTLH,
                 A_EXTLL,A_EXTQH,A_EXTQL,A_EXTWH,A_EXTWL,A_FBEQ,
                 A_FBGE,A_FBGT,A_FBLE,A_FBLT,A_FBNE,A_FCMOVEQ,
                 A_FCMOVGE,A_FCMOVGT,A_FCMOVLE,A_FCMOVLT,A_FCMOVNE,A_FETCH,
                 A_FETCH_M,A_FTOIS,A_FTOIT,A_IMPLVER,A_INSBL,A_INSLH,
                 A_INSLL,A_INSQH,A_INSQL,A_INSWH,A_INSWL,A_ITOFF,
                 A_ITOFS,A_ITOFT,A_JMP,A_JSR,A_JSR_COROUTINE,A_LDA,
                 A_LDAH,A_LDBU,A_LDWU,A_LDF,A_LDG,A_LDL,
                 A_LDL_L,A_LDQ,A_LDQ_L,A_LDQ_U,A_LDS,A_LDT,
                 A_MAXSB8,A_MAXSW4,A_MAXUB8,A_MAXUW4,A_MB,A_MF_FPCR,
                 A_MINSB8,A_MINSW4,A_MINUB8,A_MINUW4,A_MSKBL,A_MSKLH,
                 A_MSKLL,A_MSKQH,A_MSKQL,A_MSKWH,A_MSKWL,A_MT_FPCR,
                 A_MULF,A_MULG,A_MULL,A_MULQ,
                 A_MULS,A_MULT,A_ORNOT,A_PERR,A_PKLB,A_PKWB,
                 A_RC,A_RET,A_RPCC,A_RS,A_S4ADDL,A_S4ADDQ,
                 A_S4SUBL,A_S4SUBQ,A_S8ADDL,A_S8ADDQ,A_S8SUBL,A_S8SUBQ,
                 A_SEXTB,A_SEXTW,A_SLL,A_SQRTF,A_SQRTG,A_SQRTS,
                 A_SQRTT,A_SRA,A_SRL,A_STB,A_STF,A_STG,
                 A_STS,A_STL,A_STL_C,A_STQ,A_STQ_C,A_STQ_U,
                 A_STT,A_STW,A_SUBF,A_SUBG,A_SUBL,
                 A_SUBQ,A_SUBS,A_SUBT,A_TRAPB,A_UMULH,
                 A_UNPKBL,A_UNPKBW,A_WH64,A_WMB,A_XOR,A_ZAP,
                 A_ZAPNOT);

       tregister = word;

       treference = record
          offset : aword;
          symbol : pstring;
          reg : tregister;
          { the boundary to which the reference is surely aligned }
          alignement : byte;
       end;

       tloc = (LOC_INVALID,LOC_REGISTER,LOC_MEM,LOC_REFERENCE,LOC_JUMP,
               LOC_FLAGS,LOC_CREGISTER,LOC_CONST);

       tlocation = record
          case loc : tloc of
             LOC_REFERENCE,LOC_MEM : (reference : treference);
       end;

    const
       { offsets for the integer and floating point registers }
       INT_REG = 0;
       FLOAT_REG = 32;

       R_NO = $ffff;

       { operator qualifiers }
       OQ_CHOPPED_ROUNDING            = $01;  { /C }
       OQ_ROUNDING_MODE_DYNAMIC       = $02;  { /D }
       OQ_ROUND_TOWARD_MINUS_INFINITY = $04;  { /M }
       OQ_INEXACT_RSULT_ENABLE        = $08;  { /I }
       OQ_SOFTWARE_COMPLETION_ENABLE  = $10;  { /S }
       OQ_FLOATING_UNDERFLOW_ENABLE   = $20;  { /U }
       OQ_INTEGER_OVERFLOW_ENABLE     = $40;  { /V }

    { make l as a new label }
    procedure getlabel(var l : tlabel);

  implementation

    const
       nextlabelnr : aword = 1;

    procedure getlabel(var l : tlabel);

      begin
         l:=nextlabelnr;
         inc(nextlabelnr);
      end;

end.
{
  $Log: alpha.pas,v $
  Revision 1.2  1998/09/09 20:14:00  peter
    - dup files already used elsewhere

}
